//---------------------------------------------------------------------------
//
// Name:        anyport_guiDlg.cpp
// Author:      Peter Zimmermann
// Created:     07.01.2008 23:55:13
// Description: anyport_guiDlg class implementation
//
//---------------------------------------------------------------------------

#include "anyport_guiDlg.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

#include "ComEnumPorts.h"

//----------------------------------------------------------------------------
// anyport_guiDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(anyport_guiDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(anyport_guiDlg::OnClose)
	EVT_BUTTON(ID_BTNSCANPORTS,anyport_guiDlg::btnScanPortsClick)
END_EVENT_TABLE()
////Event Table End

anyport_guiDlg::anyport_guiDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

anyport_guiDlg::~anyport_guiDlg()
{
} 

void anyport_guiDlg::CreateGUIControls()
{
	//Do not add custom code here
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	SetTitle(wxT("Locate COM/USB-Ports"));
	SetIcon(wxNullIcon);
	SetSize(8,8,627,466);
	Center();
	

	btnScanPorts = new wxButton(this, ID_BTNSCANPORTS, wxT("Suche COM/USB-Ports"), wxPoint(33,344), wxSize(552,25), 0, wxDefaultValidator, wxT("btnScanPorts"));

	wxArrayString arrayStringFor_lb;
	lb = new wxListBox(this, ID_LB, wxPoint(32,65), wxSize(554,257), arrayStringFor_lb, wxLB_SINGLE);
	////GUI Items Creation End
}

void anyport_guiDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

/*
 * btnScanPortsClick
 */
void anyport_guiDlg::btnScanPortsClick(wxCommandEvent& event)
{
	// insert your code here
	int i,iCount;
	wxChar s[256];
	ComInfo *pInfo;
	
	iCount = ComEnumPorts(NULL,0);
	lb->Clear();
   if (!iCount)
      {
   
      lb->Append(wxT("No Ports found!"));
      return;
      }
   pInfo = new ComInfo[iCount];
   iCount = ComEnumPorts(pInfo,iCount);
   for (i=0; i<iCount; i++)
      {
      sprintf(s,"%i. Port",i+1);
      lb->Append(s);
      sprintf(s,"   Port = %s",pInfo[i].cPortName);
      lb->Append(s);
      sprintf(s,"   Name = %s",pInfo[i].cFriendlyName);
      lb->Append(s);
      sprintf(s,"   Path = %s",pInfo[i].cDevPath);
      lb->Append(s);
      sprintf(s,"   Desk = %s",pInfo[i].cPortDesc);
      lb->Append(s);
      sprintf(s,"   USB = %i",pInfo[i].bUsbDevice);
      lb->Append(s);
      lb->Append("");
      }
   delete pInfo;
   lb->Append(wxT("*** END ***"));
}
